Subject: Re: What's cooking in git.git (May 2021, #03; Thu, 20)

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Thu, 20 May 2021 13:25:03 +0200

On Thu, May 20 2021, Junio C Hamano wrote:

A brief summary of my outstanding stuff:

> * ab/perl-makefile-cleanup (2021-05-13) 5 commits
>   (merged to 'next' on 2021-05-13 at 6cf377a1bc)
>  + Makefile: make PERL_DEFINES recursively expanded
>   (merged to 'next' on 2021-05-10 at 23b48398e6)
>  + perl: use mock i18n functions under NO_GETTEXT=Y
>  + Makefile: regenerate *.pm on NO_PERL_CPAN_FALLBACKS change
>  + Makefile: regenerate perl/build/* if GIT-PERL-DEFINES changes
>  + Makefile: don't re-define PERL_DEFINES
>
>  Build procedure clean-up.
>
>
> * ab/sparse-index-cleanup (2021-05-06) 1 commit
>   (merged to 'next' on 2021-05-10 at bbb0239571)
>  + sparse-index.c: remove set_index_sparse_config()
>
>  Code clean-up.
>
>
> * ab/streaming-simplify (2021-05-06) 5 commits
>   (merged to 'next' on 2021-05-07 at 0992a78c75)
>  + streaming.c: move {open,close,read} from vtable to "struct git_istream"
>  + streaming.c: stop passing around "object_info *" to open()
>  + streaming.c: remove {open,close,read}_method_decl() macros
>  + streaming.c: remove enum/function/vtbl indirection
>  + streaming.c: avoid forward declarations

Thanks!

> * ab/send-email-optim (2021-05-13) 9 commits
>  - send-email: move trivial config handling to Perl
>  - perl: lazily load some common Git.pm setup code
>  - send-email: lazily load modules for a big speedup
>  - send-email: get rid of indirect object syntax
>  - send-email: use function syntax instead of barewords
>  - send-email: lazily shell out to "git var"
>  - send-email: lazily load config for a big speedup
>  - send-email: refactor sendemail.smtpencryption config parsing
>  - send-email: remove non-working support for "sendemail.smtpssl"
>
>  "git send-email" optimization.
>
>  Looking good.
>  May want to update with Eric's suggestion.
>  cf. <20210512180517.GA11354@dcvr>
>  I've squashed in typofixes while queuing.

Sent a re-roll just now in
https://lore.kernel.org/git/[email-masked]/

> * ab/update-submitting-patches (2021-05-13) 3 commits
>  - SubmittingPatches: remove pine-specific hints from MUA hints
>  - SubmittingPatches: replace discussion of Travis with GitHub Actions
>  - SubmittingPatches: move discussion of Signed-off-by above "send"
>
>  Reorganize and update the SubmitingPatches document.
>
>  Expecting a reroll.
>  cf. <[email-masked]>, <20210512235136.GB10785@localhost>

I haven't gotten back to this yet / seen what the status of my patches
v.s. Dave Huseby's are.

> * ab/describe-tests-fix (2021-05-11) 5 commits
>  - describe tests: support -C in "check_describe"
>  - describe tests: fix nested "test_expect_success" call
>  - describe tests: don't rely on err.actual from "check_describe"
>  - describe tests: refactor away from glob matching
>  - describe tests: improve test for --work-tree & --dirty
>  (this branch uses ab/test-lib-updates.)
>
>  Various updates to tests around "git describe"
>
>  Waiting for the base topic to solidify.

...

> * ab/pickaxe-pcre2 (2021-05-11) 22 commits
>  - xdiff-interface: replace discard_hunk_line() with a flag
>  - xdiff users: use designated initializers for out_line
>  - pickaxe -G: don't special-case create/delete
>  - pickaxe -G: terminate early on matching lines
>  - xdiff-interface: allow early return from xdiff_emit_line_fn
>  - xdiff-interface: prepare for allowing early return
>  - pickaxe -S: slightly optimize contains()
>  - pickaxe: rename variables in has_changes() for brevity
>  - pickaxe -S: support content with NULs under --pickaxe-regex
>  - pickaxe: assert that we must have a needle under -G or -S
>  - pickaxe: refactor function selection in diffcore-pickaxe()
>  - perf: add performance test for pickaxe
>  - pickaxe/style: consolidate declarations and assignments
>  - diff.h: move pickaxe fields together again
>  - pickaxe: die when --find-object and --pickaxe-all are combined
>  - pickaxe: die when -G and --pickaxe-regex are combined
>  - pickaxe tests: add missing test for --no-pickaxe-regex being an error
>  - pickaxe tests: test for -G, -S and --find-object incompatibility
>  - pickaxe tests: add test for "log -S" not being a regex
>  - pickaxe tests: add test for diffgrep_consume() internals
>  - pickaxe tests: refactor to use test_commit --append --printf
>  - grep/pcre2 tests: reword comments referring to kwset
>  (this branch uses ab/test-lib-updates.)
>
>  Rewrite the backend for "diff -G/-S" to use pcre2 engine when
>  available.
>
>  Waiting for the base topic to solidify.

...

> * ab/trace2-squelch-gcc-warning (2021-05-11) 1 commit
>  - trace2: refactor to avoid gcc warning under -O3
>
>  Workaround compiler warnings.
>
>  Expecting a reroll.
>  cf. <[email-masked]>

Re-rolled as
https://lore.kernel.org/git/[email-masked]/
(but as of writing this lore hasn't picked it up, but I'm pretty sure
I've sent it...)

> * ab/test-lib-updates (2021-05-11) 11 commits
>  - test-lib: split up and deprecate test_create_repo()
>  - test-lib: do not show advice about init.defaultBranch under --verbose
>  - test-lib: reformat argument list in test_create_repo()
>  - submodule tests: use symbolic-ref --short to discover branch name
>  - test-lib functions: add --printf option to test_commit
>  - describe tests: convert setup to use test_commit
>  - test-lib functions: add an --annotated option to "test_commit"
>  - test-lib-functions: document test_commit --no-tag
>  - test-lib-functions: reword "test_commit --append" docs
>  - test-lib tests: remove dead GIT_TEST_FRAMEWORK_SELFTEST variable
>  - test-lib: bring $remove_trash out of retirement
>  (this branch is used by ab/describe-tests-fix and ab/pickaxe-pcre2.)
>
>  Test clean-up.

I think per the v6 discussion at
https://lore.kernel.org/git/[email-masked]/
this is ready to proceed. I.e. there's an ack + some discussion about
wording of "deprecated" not directly relevant to that topic.

It would be great to get this un-clogged, so my other topics depending
on it can proceed, but of course the rc period and all that...

> * ab/fsck-unexpected-type (2021-04-13) 6 commits
>  . fsck: report invalid object type-path combinations
>  . fsck: report invalid types recorded in objects
>  . object-store.h: move read_loose_object() below 'struct object_info'
>  . fsck: don't hard die on invalid object types
>  . fsck tests: refactor one test to use a sub-repo
>  . cache.h: move object functions to object-store.h
>
>  "git fsck" has been taught to report mismatch between expected and
>  actual types of an object better.
>
>  Retracted for now.
>  cf. <[email-masked]>

I re-rolled this just now as
https://lore.kernel.org/git/[email-masked]
but ditto about not being on lore yet..